from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "base.zip",down_path)
download_file(xz_url + "toonshader.blend",down_path)


bl_info = {
    "name": "Stylized shaders",
    "author": "Pratik solanki",
    "version": (3, 0, 0),
    "blender": (3, 6, 0),
    "location": "N panel",
    "description":"Effortless npr look development workflow",
    "warning": "",
    "doc_url": "https://blendermarket.com/products/stylizedshaders",
    "category": "Object"
}






import bpy, os
from bpy.types import (
    Operator,
    Panel,
    PropertyGroup,
)
from bpy.props import *
import bpy.utils.previews
from bpy.types import WindowManager


class Object_OT_Addstlshader(Operator):
    bl_idname = "add.stlshader"
    bl_label = "Add Object"
    

    def execute(self, context):
        script_dir = os.path.dirname(__file__)
        material_path = os.path.join(script_dir, 'toonshader.blend')
        print("INFO:", material_path)
        name = bpy.data.window_managers["WinMan"].stl_previews
        mat = os.path.splitext(name)[0]
        

        
        existing_material_name = mat
        existing_material = bpy.data.materials.get(existing_material_name)

        # If the material doesn't exist, import it from the file
        if not existing_material:
            with bpy.data.libraries.load(material_path) as (data_from, data_to):
                data_to.materials = [existing_material_name]
            existing_material = data_to.materials[0]
        else:
            existing_material = bpy.data.materials[existing_material_name].copy()

        # Link the material to the active object's material slots
        obj = bpy.context.object
        if obj:
            if len(obj.data.materials) == 0:
                obj.data.materials.append(None)  # Add a new material slot if none exists


            obj.data.materials[obj.active_material_index] = existing_material
        
            
        bpy.context.view_layer.update() 
        bpy.ops.object.editmode_toggle()
        bpy.ops.object.editmode_toggle()

       
                

        return{'FINISHED'}
class Object_OT_refreshnodes(Operator):
    bl_idname = "refresh.stlshader"
    bl_label = "Add Object"
    

    def execute(self, context):
        
        current = bpy.context.area.ui_type
       # bpy.context.area.type = 'NODE_EDITOR'
        bpy.context.area.ui_type = 'ShaderNodeTree'

        # Get the active material of the active object
        material = bpy.context.object.active_material

        # Get the material output node
        material_output_node = material.node_tree.nodes.get('Material Output')

        # Get the node connected to the material output node
        connected_node = material_output_node.inputs['Surface'].links[0].from_node

        # Deselect all nodes
        #bpy.ops.node.select_all(action='DESELECT')

        # Select the connected node
        connected_node.select = True

        # Set the material node tree as the active node tree
        #bpy.context.object.active_material.node_tree = material.node_tree

        # Set the connected node as the active node
        material.node_tree.nodes.active = connected_node
        

        bpy.context.area.ui_type = current

            
            
       
                

        return{'FINISHED'}
        


def update_category(self, context):
    enum_previews_from_directory_items(self, context)


class Categories(PropertyGroup):
    Stl_options = [
        ("0", "Shader",'', 0),
        ("1", "Outline",'',1),
        ("2", "World",'',2),
    ]
    
    Stl_cat = [
        ("0", "Toon",'', 0),
        ("1", "Comic",'',1),
        ("2", "Stylized",'',2),
        ("3", "Nature",'',3),
        ("4", "Painted",'',4),
        ("5", "Pattern",'',5),
        ("6", "Effects",'',6),
        ("7", "Base",'',7),
        ("8", "Simple",'',8),
        ("9", "dither",'',9),
        
    ]
    
    sshighlight: bpy.props.BoolProperty()
    #ssgradient: bpy.props.BoolProperty()
    

    cat: bpy.props.EnumProperty(
        items=Stl_options,
        description="Select a Category",
        default="0"
    )
    subcat: bpy.props.EnumProperty(
        items=Stl_cat,
        description="Select a Category",
        default="0"
    )
    
    globallineset: bpy.props.FloatProperty(default=-0.05)
    linesetting: bpy.props.BoolProperty()
    
    


def enum_previews_from_directory_items(self, context):

    category = context.scene.st_tool.cat
    
    subcat = context.scene.st_tool.subcat
    #Extensions
    extensions = ('.jpeg', '.jpg', '.png')
    

    # Icons Directory    
    

    pcoll = preview_collections["main"]
    
    
    enum_items = []

    if context is None:
        return enum_items
    
    
    if category == '0':
        if subcat == '0':
            directory = os.path.join(os.path.dirname(__file__), "toon")
            

        if subcat == '1':
            directory = os.path.join(os.path.dirname(__file__), "comic")
        if subcat == '2':
            directory = os.path.join(os.path.dirname(__file__), "stylized")
        if subcat == '3':
            directory = os.path.join(os.path.dirname(__file__), "nature")
        if subcat == '4':
            directory = os.path.join(os.path.dirname(__file__), "painted")
        if subcat == '5':
            directory = os.path.join(os.path.dirname(__file__), "pattern")
        if subcat == '6':
            directory = os.path.join(os.path.dirname(__file__), "effects")
        if subcat == '7':
            directory = os.path.join(os.path.dirname(__file__), "base")
        if subcat == '8':
            directory = os.path.join(os.path.dirname(__file__), "simple")
        if subcat == '9':
            directory = os.path.join(os.path.dirname(__file__), "dither")
            
    elif category == '2':
        directory = os.path.join(os.path.dirname(__file__), "world images")
    if directory == pcoll.stl_previews_dir:
        
        return pcoll.stl_previews

    if directory and os.path.exists(directory):
        # Scan the directory for png files
        image_paths = []
        for fn in os.listdir(directory):
            if fn.lower().endswith(extensions):
                image_paths.append(fn)

        for i, name in enumerate(image_paths):
            # generates a thumbnail preview for a file.
            filepath = os.path.join(directory, name)
            icon = pcoll.get(name)
            if filepath in pcoll:
                enum_items.append((name, name, "", pcoll[filepath].icon_id, i))
            else:
                thumb = pcoll.load(filepath, filepath, 'IMAGE')
                
                enum_items.append((name, name, "", thumb.icon_id, i))
    

    pcoll.stl_previews = enum_items
    pcoll.stl_previews_dir = directory
    
    return pcoll.stl_previews

def is_node_input_connected(socket):
    return socket.is_linked

def is_image_texture_node(node):
    return node.type == 'TEX_IMAGE'

def draw_group_node_input(layout, node, input_socket):
    if is_image_texture_node(input_socket) and is_node_input_connected(input_socket):
        layout.row(align=True)  # Display a blank row for connected inputs
    else:
        layout.template_node_view(node, input_socket)
        
   
        
        
class Stylizedshaders(Panel):
    """Creates a Panel in the Object properties window"""
    bl_label = "Stylized shaders"
    bl_idname = "STYLIZED_PT_previews"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "SS"
    
    
    
    def draw(self, context):
        layout = self.layout
        wm = context.window_manager
        scene = context.scene
        sttool = scene.st_tool
        obj = bpy.context.active_object

        

        row = layout.row()
        row.scale_y = 1.5
        row.prop(scene.st_tool, "cat", expand = True)
        
        row = layout.row()
        
        
        
        if sttool.cat == '0':
            row = layout.row()
            row.scale_y = 1.5
            row.prop(scene.st_tool, "subcat", expand = False, text = 'Category')
            row = layout.row()
            row.template_icon_view(wm, "stl_previews", show_labels=True,scale=8,scale_popup=8)

            row = layout.row(align = True)
            row.scale_y = 1.5
            row.operator("add.stlshader", icon="NODE_MATERIAL", text="Assign")
            row = layout.row(align = True)
            
            
            
            row = layout.row()
            
            if obj is not None and obj.type in {'MESH', 'CURVE', 'FONT'}:
                if obj.data.materials:
                    if context.active_object.active_material:
                        
                        #row.prop(context.active_object.active_material,'name')
                        row.template_ID(context.active_object, "active_material", new="material.new")
                    row = layout.row()
                    row.popover(panel="NODE_PT_material_slots")
                    row.operator("refresh.stlshader", text="",icon='FILE_REFRESH')
                    active_material = obj.active_material
                    name = active_material.name
            
           
                    mat = bpy.context.object.active_material
                    ntree2 = mat.node_tree
                    #node = ntree2.nodes.active
                    group_nodes = [node for node in ntree2.nodes if node.type == 'GROUP']
                    #box = layout.box()
                    for node in group_nodes:
                        for socket in node.inputs:
                            row = layout.row(align=True)
                            row.alignment = 'CENTER'
                            if socket.name == 'use texture':
                                continue
                            row = layout.row(align=True)
                            row.alignment = 'CENTER'
                            
                            if socket.name=='Shadow' or socket.name=='Color' or socket.name=='Texture' or socket.name=='Color1' :
                                box = layout.box()
                                box.label(text='Color',icon = 'GRIP')
                                #row.separator(factor=3.0)
                                
                                #row.label(text='------------------------------------------------------------------------------------------------------------------------------------')
                                #layout.label(text='color')
                            if socket.name=='Gradient':
                                
                                box = layout.box()
                                #row.separator(factor=1.0)
                                #row = box.row(align=True)
                                box.label(text='Gradients',icon = 'GRIP')
                                
                                #row.label(text='------------------------------------------------------------------------------------------------------------------------------------')
                            if socket.name=='Rim color':
                                box = layout.box()
                                box.label(text='Rim',icon = 'GRIP')
                            if socket.name=='Specular':
                                box = layout.box()
                                box.label(text='Specular',icon = 'GRIP')
                            if socket.name=='strokes':
                                box = layout.box()
                                box.label(text='Strokes',icon = 'GRIP')
                            if socket.name=='cavity':
                                box = layout.box()
                                box.label(text='Cavity',icon = 'GRIP')
                            if socket.name=='lines':
                                box = layout.box()
                                box.label(text='Lines',icon = 'GRIP')
                            if socket.name=='moss':
                                box = layout.box()
                                box.label(text='Moss',icon = 'GRIP')
                            if socket.name=='Flower':
                                box = layout.box()
                                box.label(text='Flower',icon = 'GRIP')
                            if socket.name=='Strokes':
                                box = layout.box()
                                box.label(text='Strokes',icon = 'GRIP')
                            if socket.name=='Duel Rim':
                                box = layout.box()
                                box.label(text='Duel Rim',icon = 'GRIP')
                            if socket.name=='Star scale':
                                box = layout.box()
                                box.label(text='Effect',icon = 'GRIP')
                            if socket.name=='Hatch Scale':
                                box = layout.box()
                                box.label(text='Hatch',icon = 'GRIP')
                            if socket.name=='edge':
                                box = layout.box()
                                box.label(text='Edge Wear',icon = 'GRIP')
                            if socket.name=='bump':
                                box = layout.box()
                                box.label(text='Bump',icon = 'GRIP')
                                
                                
                                
                                
                            if is_node_input_connected(socket):
                                
                                
                                continue
                            
                            
                            
                            layout.template_node_view(ntree2, node, socket)
                else:
                    layout.label(text="No materials assigned to the object.")
            else:
                row.label(text="No active object selected.")





            #for node in group_nodes:
                #for socket in node.inputs:
                    #layout.template_node_view(ntree2, node,socket)
               
           # for socket in node.inputs:
                #layout.template_node_view(ntree2, node,socket)
                    
            
            
        elif sttool.cat =='1':
            
            row = layout.row(align = True)
            box = row.box()
            row = box.row(align = True)
            row.scale_y = 1.5
            row.scale_x = 1.5
            #row.label(text = 'outline')
            row.operator("object.st_outline",text = 'add outline')
            row.operator("object.st_remove",text = '',icon ='CANCEL')
            row.prop(scene.st_tool, "linesetting",toggle = True,text='',icon = 'PREFERENCES')
            if scene.st_tool.linesetting == True:
                
                #box = layout.box()
                row = box.row()
                row.scale_y = 1.5
                row.prop(scene.st_tool, "globallineset", text = 'global thickness')
            row = layout.row(align = True)
                
            row = layout.row(align = True)
            
            row.scale_y = 1.5
            if 'ST_OUTLINE' in context.active_object.modifiers:
                # Add a row label with 'hello'
                row.prop(context.active_object.modifiers['ST_OUTLINE'],'thickness')
                #row = layout.row()
            if not bpy.context.active_object.data.materials:
                row = layout.row(align = True)
                row.label(text='No materials')
            
            
            #elif any(material.name.startswith("ST_Outline") for material in context.active_object.data.materials):
                
            matching_material = None

            for material in context.active_object.data.materials:
                if material.name.startswith("ST_Outline"):
                    matching_material = material
                    break

           # elif active_material and active_material.name.startswith("ST_Outline"):
            if matching_material:
                
                row.prop(matching_material.node_tree.nodes["Group"].inputs[0],'default_value',text ='')
                row = layout.row(align = True)
                row.scale_y = 1.5
                row.prop(matching_material.node_tree.nodes["Group"].inputs[1],'default_value',text ='Noise')
                row = layout.row(align = True)
                row.scale_y = 1.5
                row.prop(matching_material.node_tree.nodes["Group"].inputs[2],'default_value',text ='Detail')
                row = layout.row(align = True)
                row.scale_y = 1.5
                row.prop(matching_material.node_tree.nodes["Group"].inputs[3],'default_value',text ='Distance')
                
                
                
        elif sttool.cat =='2':
            row = layout.row()
            
            row.template_icon_view(wm, "stl_previews", show_labels=True,scale=8,scale_popup=8)

            row = layout.row(align = True)
            row.operator("setworld.st",text = 'set world')
            row = layout.row(align = True)
            
            
            active_world = context.scene.world
            if active_world and active_world.name == "toonworld":
                node_tree = active_world.node_tree
                evtex_node = node_tree.nodes.get("evtex")
                background_node = node_tree.nodes.get("Background")
                connection_found = False

                if evtex_node and background_node:
                    # Check if there's a connection between "evtex" and "background" nodes
                    for link in node_tree.links:
                        if link.from_node == evtex_node and link.to_node == background_node:
                            row.prop(active_world.node_tree.nodes["Combine XYZ"].inputs[2], "default_value", text="Rotate")
                            connection_found = True
                            break
                
                
                
                if not connection_found:
                   row.scale_y = 1.5
                   row.prop(active_world.node_tree.nodes["Background"].inputs[0], "default_value", text="")

                

        
       
        
            
class set_OT_toonworld(bpy.types.Operator):
    """Tooltip"""
    bl_idname = "setworld.st"
    bl_label = "set world"
    bl_options = {'REGISTER'}

   
        
    def execute(self, context):
        scn = context.scene
        
        scene = bpy.context.scene
        bpy.context.scene.render.engine = 'BLENDER_EEVEE'
        nwor = bpy.data.worlds.get('toonworld')
        #directory = bpy.context.preferences.addons[__name__].preferences.globpath
        script_dir = os.path.dirname(__file__)
        filepath = os.path.join(script_dir,'world images')
        
        if nwor is None:
            #if scene.world is None:
            # create a new world
            #nwor = bpy.data.worlds.new("toonworld")
            script_dir = os.path.dirname(__file__)
            world_path = os.path.join(script_dir,'world','toonworld.blend')
        
        
        
            # Append the world from the blend file
            with bpy.data.libraries.load(world_path, link=False) as (data_from, data_to):
                data_to.worlds = ['toonworld']  # Append with the name 'toonworld'
        
            # Set the imported world as the active world
            if data_to.worlds:
                nwor = bpy.data.worlds.get('toonworld')
                bpy.context.scene.world = nwor
                
                self.report({'INFO'}, f"World set from: {world_path}")
            else:
                self.report({'WARNING'}, f"No world found in the blend file: {self.blendfile_path}")


            
        else:
            
            bpy.context.scene.world = nwor
        stl = bpy.data.window_managers["WinMan"].stl_previews
        
        
        if bpy.context.scene.world and bpy.context.scene.world.node_tree:
            world_node_tree = bpy.context.scene.world.node_tree
            if "evtex" in world_node_tree.nodes:
                evtex_node = world_node_tree.nodes["evtex"]
                bg = world_node_tree.nodes["Background"]
                
                image_path = os.path.join(filepath, stl)
                
                if stl == 'basic.png':
                    output = evtex_node.outputs[0]
                    input  = bg.inputs[0]
                    for l in output.links :
                        if l.to_socket == input :
                           world_node_tree.links.remove(l)
                    
                    
                    
    
                else:
                        
                    world_node_tree.links.new(bg.inputs[0],evtex_node.outputs[0])
                    
                    bpy.data.images.load(image_path, check_existing=True)
                    
                     
                    
                    evtex_node.image = bpy.data.images[stl]
                
        

        
        '''world = bpy.data.worlds['toonworld']
        world.use_nodes = True
        ntree = world.node_tree
        bg = ntree.nodes.get('bg',None)
        bg2 = ntree.nodes.get('bg2',None)
       
        mix = ntree.nodes.get('mix',None)
        lightpath = ntree.nodes.get('lightpath',None)
        otp =  ntree.nodes.get('otp',None)
        if bg is None:
            bg = world.node_tree.nodes['Background']
            bg.name = 'bg'
        if bg2 is None:
            #bpy.ops.node.add_node(type="ShaderNodeBackground", use_transform=True)

            bg2 = world.node_tree.nodes.new(type="ShaderNodeBackground")
            bg2.name = 'bg2'
            bg2 = world.node_tree.nodes['bg2']
        if mix is None:
            mix = world.node_tree.nodes.new(type="ShaderNodeMixShader")
            mix.name = 'mix'
            mix = world.node_tree.nodes['mix']    
       
            
        if otp is None:
            otp = world.node_tree.nodes['World Output']
            otp.name = 'otp'
            
            
            #bpy.ops.node.add_node(type="ShaderNodeTexCoord", use_transform=True)
            #bpy.ops.node.add_node(type="ShaderNodeMapping", use_transform=True)


        
            
        if lightpath is None:
            lightpath = world.node_tree.nodes.new(type="ShaderNodeLightPath")
            lightpath.name = 'lightpath'
            lightpath = world.node_tree.nodes['lightpath']       
            
        #bpy.ops.node.add_node(type="ShaderNodeLightPath", use_transform=True)

        ntree.links.new(mix.inputs[0],lightpath.outputs[0])      
        ntree.links.new(mix.inputs[1],bg.outputs[0])  
        ntree.links.new(mix.inputs[2],bg2.outputs[0])  
        
        ntree.links.new(otp.inputs[0],mix.outputs[0])'''
        
        

        
        
        
            
        
        

            
        return {'FINISHED'} 
            
class stylized_OT_Removelines(bpy.types.Operator):
    bl_idname = "object.st_remove"
    bl_label = "Remove Outline"
    bl_description = "Remove outline"
    bl_options = { "REGISTER", "UNDO"}

    @classmethod    
    def poll(cls, context):
        return (bpy.context.object.mode != "EDIT")

    def execute(self, context):

            

        sel = bpy.context.selected_objects
        # Iterate through selected objects
        for obj in sel:
            if obj.type in ["MESH", "CURVE"]:
                bpy.context.view_layer.objects.active = obj

                matindex = obj.data.materials.find('ST_Outline')
                if matindex != -1:
                    obj.data.materials.pop(index=matindex)

                there = False

                for mod in bpy.context.object.modifiers:
                    if mod.name == "ST_OUTLINE":
                        there = True

                if there:
                    mod = bpy.context.object.modifiers["ST_OUTLINE"]
                    obj.modifiers.remove(mod)
                
        
           
 

        return {"FINISHED"}       
        
class Stylized_OT_Outline(bpy.types.Operator):
    bl_idname = "object.st_outline"
    bl_label = "Set Outline"
    bl_description = "Add outline"
    bl_options = { "REGISTER" , "UNDO" }

  
   
    def execute(self, context):

        sel = bpy.context.selected_objects
        mytool = context.scene.st_tool
        
        sel = bpy.context.selected_objects
        for obj in sel:
            if obj.type in ["MESH", "CURVE"]:
                bpy.context.view_layer.objects.active = obj

                nomat = True

                for slot in obj.data.materials:
                    if slot is not None:
                        if slot.name == "ST_Outline":
                            nomat = False
                if nomat:
                    mat = bpy.data.materials.get("ST_Outline")
                   

                    if mat is None:
                        script_dir = os.path.dirname(__file__)
                        material_path = os.path.join(script_dir, 'toonshader.blend')
                        
                        mat = 'ST_Outline'
                        #mat = os.path.splitext(name)[0]
                        

                        
                        existing_material_name = mat
                        existing_material = bpy.data.materials.get(existing_material_name)

                        # If the material doesn't exist, import it from the file
                        if not existing_material:
                            with bpy.data.libraries.load(material_path) as (data_from, data_to):
                                data_to.materials = [existing_material_name]
                            existing_material = data_to.materials[0]
                        else:
                            existing_material = bpy.data.materials[existing_material_name].copy()
                        
                        
                        
                        
                        

                    bpy.context.object.data.materials.append(bpy.data.materials.get("ST_Outline"))

                #Modifier

                there = False

                for mod in bpy.context.object.modifiers:
                    if mod.name == "ST_OUTLINE":
                        there = True

                if there:
                    mod = bpy.context.object.modifiers["ST_OUTLINE"]
                    mod.thickness = mytool.globallineset
                else: 
                    obj.modifiers.new("ST_OUTLINE","SOLIDIFY")
                    mod = obj.modifiers["ST_OUTLINE"]
                    mod.use_flip_normals = True
                    mod.use_rim = False
                    mod.thickness = mytool.globallineset
                    mod.material_offset = 999
        
        return {"FINISHED"}






# We can store multiple preview collections here,
# however in this example we only store "main"
preview_collections = {}


def register():

    WindowManager.stl_previews_dir = StringProperty(
        name="Folder Path",
        subtype='DIR_PATH',
        default=""
    )

    WindowManager.stl_previews = EnumProperty(
        items=enum_previews_from_directory_items,
    )

    pcoll = bpy.utils.previews.new()
    pcoll.stl_previews_dir = ""
    pcoll.stl_previews = ()

    preview_collections["main"] = pcoll

    bpy.utils.register_class(Object_OT_Addstlshader)
    bpy.utils.register_class(Object_OT_refreshnodes)
    bpy.utils.register_class(set_OT_toonworld)
    bpy.utils.register_class(stylized_OT_Removelines)
    bpy.utils.register_class(Stylized_OT_Outline)
    bpy.utils.register_class(Categories)
    bpy.types.Scene.st_tool = PointerProperty(type=Categories)
    bpy.utils.register_class(Stylizedshaders)
    


def unregister():

    del WindowManager.stl_previews
    

    

    bpy.utils.unregister_class(Object_OT_Addstlshader)
    bpy.utils.unregister_class(Object_OT_refreshnodes)
    bpy.utils.unregister_class(set_OT_toonworld)
    bpy.utils.unregister_class(stylized_OT_Removelines)
    
    bpy.utils.unregister_class(Stylized_OT_Outline)
    bpy.utils.unregister_class(Categories)
    del bpy.types.Scene.st_tool
    bpy.utils.unregister_class(Stylizedshaders)
    
    for pcoll in preview_collections.values():
        bpy.utils.previews.remove(pcoll)
    preview_collections.clear()
    


if __name__ == "__main__":
    register()